/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.wrapper;

import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.base.objects.factory.EntaxyFactory;
import ru.entaxy.platform.base.objects.factory.EntaxyFactoryException;
import ru.entaxy.platform.core.producer.api.EntaxyWrappedFactory;

public abstract class AbstractFactoryWrapper implements EntaxyWrappedFactory {

	public static interface GenerationProcessor {
		
		public default void preGenerate(EntaxyWrappedFactory wrappedFactory, String outputType, String scope
				, String objectType, Map<String, Object> parameters)  throws EntaxyFactoryException{
			
		};
		
		public default void postGenerate(EntaxyWrappedFactory wrappedFactory, String outputType, String scope
				, String objectType, Map<String, Object> parameters, Generated generated)  throws EntaxyFactoryException{
			
		};
		
	}

	protected GenerationProcessor generationProcessor = null;
	
	public AbstractFactoryWrapper(EntaxyFactory origin) {
		super();
	}

	public void setGenerationProcessor(GenerationProcessor generationProcessor) {
		this.generationProcessor = generationProcessor;
	}

	public abstract void addField(FieldInfo fieldInfo);

	public abstract void addField(String outputType, FieldInfo fieldInfo);

}
