/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-management
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.management.impl;

import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import ru.entaxy.platform.core.producer.api.EntaxyProducerService;

@Component(service = ProducerServiceHelper.class, immediate = true)
public class ProducerServiceHelper {

	private static ProducerServiceHelper _instance;
	
	public static ProducerServiceHelper getInstance() {
		return _instance;
	}
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	EntaxyProducerService producerService;
	
	@Activate
	public void activate() {
		ProducerServiceHelper._instance = this;
	}
}
