/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.shell.completers;

import java.util.List;

import org.apache.karaf.shell.api.action.lifecycle.Reference;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.api.console.CommandLine;
import org.apache.karaf.shell.api.console.Completer;
import org.apache.karaf.shell.api.console.Session;
import org.apache.karaf.shell.support.completers.StringsCompleter;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory;
import ru.entaxy.platform.core.producer.api.EntaxyProducer;
import ru.entaxy.platform.core.producer.api.EntaxyProducerService;

@Service
public class FactoryIdCompleter implements Completer {

	@Reference
	EntaxyProducerService entaxyProducerService;

	@Override
	public int complete(Session session, CommandLine commandLine, List<String> candidates) {
		
		StringsCompleter delegate = new StringsCompleter();
		try {
        	for (EntaxyProducer producer : entaxyProducerService.getAllProducers()) {
        		for (EntaxyFactory factory: producer.getAllFactories())
        			delegate.getStrings().add(factory.getFactoryId());
            }
        } catch (Exception e) {
        	// nothing to do
        }
		
        return delegate.complete(session, commandLine, candidates);
	}
	
}
